%Optimierung im Zeitbereich, Minimum-Berechnung
%Zeitquadratgewichtete Betragsregelflche, ISTAE
%optimierung_ISTAE_ramp.m
% Eingangsgre Rampenfunktion

clear, clc, format long

delta_t = 0.0001; tmax = 150.0; nn = round (tmax / delta_t);
x = zeros (nn+1,1);t = zeros (nn+1,1);
t = 0:delta_t:tmax; w = t'; tt = (t .* t)';
dfa = 1.0e-4; df_min = 0.75e-4; nmax = 8;
%om = 0.7
berechne = 1; n = 2; %Ergebnisse
A_ISTAE = 4.540687135109345; f1m = 1.6825;
%Minimum-Berechnung
A_min = inf; df =  dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0; 
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df   
    G_ISTAE_r(n) = tf([f1 1], [1 f1 1]);
    x = lsim(G_ISTAE_r(n), w, t);
    A = delta_t * trapz(tt .* abs(w - x));
    if A_min > A + eps
       A_min = A; f1_min = f1; anz_min = anz_min + 1;
    end
end
j = j + 1, df, anz_min, A_ISTAE = A_min, f1m = f1_min
end
df = df / 2.0;
end
G_ISTAE_r(n) = tf([f1m 1], [1 f1m 1]);
 
berechne = 0; n = 3; %Ergebnisse
A_ISTAE = 10.163248536423447; f1m = 2.3982; f2m = 1.8230;
%Minimum-Berechnung
A_min = inf; df =  dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df 
    for f2 = f2m-df:df:f2m+df 
        G_ISTAE_r(n) = tf([f1 1], [1 f2 f1 1]);
        x = lsim(G_ISTAE_r(n), w, t);
        A = delta_t * trapz(tt .* abs(w - x));
        if A_min > A + eps
           A_min = A; anz_min = anz_min + 1; f1_min = f1; f2_min = f2;
        end
    end
end
j = j + 1, df, anz_min, A_ISTAE = A_min, f1m = f1_min, f2m = f2_min,
end
df = df / 2.0;
end
G_ISTAE_r(n) = tf([f1m 1], [1 f2m f1m 1]);

berechne = 0; n = 4; %Ergebnisse
A_ISTAE =  25.953599054416689; 
%AAA = A_ISTAE/ om^4
f1m = 2.7655; f2m = 3.5734; f3m = 2.2533;
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df 
    for f2 = f2m-df:df:f2m+df 
        for f3 = f3m-df:df:f3m+df
            G_ISTAE_r(n) = tf ([f1 1], [1 f3 f2 f1 1]);
  %G_ISTAE_r(n) = tf ([f1*om^3 1*om^4], [1 f3*om f2*om^2 f1*om^3 1*om^4]);
            x = lsim(G_ISTAE_r(n), w, t);
            A = delta_t * trapz(tt .* abs(w - x));
            if A_min > A + eps
               A_min = A; anz_min = anz_min + 1; 
               f1_min = f1; f2_min = f2; f3_min = f3;
            end
        end
    end
end
j = j + 1, df, anz_min, A_ISTAE = A_min%, AAA
f1m = f1_min, f2m = f2_min, f3m = f3_min 
end
df = df / 2.0;
end
G_ISTAE_r(n) = tf ([f1m 1], [1 f3m f2m f1m 1]);

berechne = 0; n = 5; %Ergebnisse
A_ISTAE =  45.548689701086722;
f1m =  3.4826; f2m =  5.0523; f3m =  4.8436; f4m =  2.2913; 
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
    for f2 = f2m-df:df:f2m+df
        for f3 = f3m-df:df:f3m+df
            for f4 = f4m-df:df:f4m+df           
                G_ISTAE_r(n) = tf ([f1 1], [1 f4 f3 f2 f1 1]); 
                x = lsim(G_ISTAE_r(n), w, t);
                A = delta_t * trapz(tt .* abs(w - x));
                if A_min > A
                   A_min = A; anz_min = anz_min + 1;
                   f1_min = f1; f2_min = f2; f3_min = f3; f4_min = f4;
                end
            end
        end
    end
end
j = j + 1, df, anz_min, A_ISTAE = A_min,
f1m = f1_min, f2m = f2_min, f3m = f3_min, f4m = f4_min
end
df = df / 2.0;
end
G_ISTAE_r(n) = tf ([f1m 1], [1 f4m f3m f2m f1m 1]);

berechne = 0; n = 6; %Ergebnisse
A_ISTAE = 81.984891143176313; f1m = 3.8585; f2m = 7.2090;
f3m = 7.7148; f4m = 6.0530; f5m = 2.5393;
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
    for f2 = f2m-df:df:f2m+df
        for f3 = f3m-df:df:f3m+df
            for f4 = f4m-df:df:f4m+df           
                for f5 = f5m-df:df:f5m+df
                    G_ISTAE_r(n) = tf ([f1 1], [1 f5 f4 f3 f2 f1 1]);
                    x = lsim(G_ISTAE_r(n), w, t);
                    A = delta_t * trapz(tt .* abs(w - x));
                    if A_min > A + eps
                    A_min = A; anz_min = anz_min + 1; 
                    f1_min = f1; f2_min = f2; f3_min = f3; f4_min = f4;
                    f5_min = f5;
                    end
                end
            end
        end
    end
end
j = j + 1, df, anz_min, A_ISTAE = A_min, f1m = f1_min, 
f2m = f2_min, f3m = f3_min, f4m = f4_min, f5m = f5_min 
end
df = df / 2.0;
end
G_ISTAE_r(n) = tf ([f1m 1], [1 f5m f4m f3m f2m f1m 1]);

berechne = 0; n = 7; %Ergebnisse
A_ISTAE = 1.281923123687405e+002;
f1m =  4.5435; f2m =  9.3275; f3m = 12.5516;
f4m = 10.4599; f5m =  7.2312; f6m =  2.5444;
%Minimum-Berechnung
A_min = inf; df = 2.0*dfa;
while df > 2.0*df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
    for f2 = f2m-df:df:f2m+df 
        for f3 = f3m-df:df:f3m+df 
            for f4 = f4m-df:df:f4m+df            
                for f5 = f5m-df:df:f5m+df 
                    for f6 = f6m-df:df:f6m+df
                    G_ISTAE_r(n) = tf ([f1 1], [1 f6 f5 f4 f3 f2 f1 1]);
                    x = lsim(G_ISTAE_r(n), w, t); 
                    A = delta_t * trapz(tt .* abs(w - x));
                    if A_min > A + eps
                    A_min = A; anz_min = anz_min + 1; 
                    f1_min = f1; f2_min = f2; f3_min = f3;
                    f4_min = f4; f5_min = f5; f6_min = f6;
                    end
                    end
                end              
            end
        end
    end
end
j = j + 1, df, anz_min, A_ISTAE = A_min,
f1m = f1_min, f2m = f2_min, f3m = f3_min
f4m = f4_min, f5m = f5_min, f6m = f6_min 
end
df = df / 2.0;
end
G_ISTAE_r(n) = tf ([f1m 1], [1 f6m f5m f4m f3m f2m f1m 1]);

berechne = 0; n = 8; %Ergebnisse
A_ISTAE = 1.995062165706836e+002;
f1m =  4.9419; f2m = 11.9464; f3m = 17.5537; f4m = 19.0275;
f5m = 13.5835; f6m =  8.4056; f7m =  2.7053;   
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df, 
    f1
    for f2 = f2m-df:df:f2m+df 
        for f3 = f3m-df:df:f3m+df 
            for f4 = f4m-df:df:f4m+df            
                for f5 = f5m-df:df:f5m+df 
                    for f6 = f6m-df:df:f6m+df
                    for f7 = f7m-df:df:f7m+df
                    G_ISTAE_r(n) = tf ([f1 1], [1 f7 f6 f5 f4 f3 f2 f1 1]);
                    x = lsim(G_ISTAE_r(n), w, t);
                    A = delta_t * trapz(tt .* abs(w - x));
                    if A_min > A + eps
                    A_min = A; anz_min = anz_min + 1; 
                    f1_min = f1; f2_min = f2; f3_min = f3; f4_min = f4;
                    f5_min = f5; f6_min = f6; f7_min = f7;
                    end
                    end
                    end
                end
            end
        end
    end
end
j = j + 1, df, anz_min, A_ISTAE = A_min,
f1m = f1_min, f2m = f2_min, f3m = f3_min
f4m = f4_min, f5m = f5_min, f6m = f6_min, f7m = f7_min 
end
df = df / 2.0;
end
G_ISTAE_r(n) = tf ([f1m 1], [1 f7m f6m f5m f4m f3m f2m f1m 1]);

t = 0:10.0*delta_t:8; w = t';
subplot(121)
hold off
for n = 2:nmax
        x = lsim(G_ISTAE_r(n), w, t);
        plot(t, x), hold on, grid on
end
plot(t, w, 'k:')
axis ([0 8 -0.25 8.25])
title('ISTAE-Optimierung des')
xlabel('Zeit t / s'), ylabel('Anstiegsantwort x(t)')

subplot (122)
hold off
for n = 2:nmax
        x = lsim(G_ISTAE_r(n), w, t);
        plot(t, (w - x)), hold on, grid on
end
axis ([0 8 -0.1 3.075])
title('Geschwindigkeitsfehlers fr w(t) = t, \omega_k = 1 s^-^1')
xlabel('Zeit t / s'), ylabel('Regeldifferenz e(t) = w(t) - x(t)')

