%MATLAB Script-File be_z_162.m
%Betrag einer komplexen Zahl

Re=linspace(-1,1,30); %Vektor mit linearer Teilung
Im=Re;
z=sqrt(Re.^2+Im.^2);  %Betrag der komplexen Zahl
[RE,IM]=meshgrid(Re,Im); %Matrizen RE, IM fr 3D-Plots
Z=sqrt(RE.^2+IM.^2);
clf
subplot(221), plot3(Re,Im,z)	%3D-Liniengrafik
grid on							%Gitterlinien
title('\it{3D-Liniengrafik}')	%Titel der Grafik
xlabel('\it{Realteil}')			%Bezeichnung der x-Achse
ylabel('\it{Imaginrteil}')		%Bezeichnung der y-Achse
zlabel('\it{Betrag von z}')		%Bezeichnung der z-Achse
subplot(222), contour(RE,IM,Z)	%2D-Hhenlinien
grid on
title('\it{2D-Hhenlinien}')
xlabel('\it{Realteil}')
ylabel('\it{Imaginrteil}')
zlabel('\it{Betrag von z}')
subplot(223), contour3(RE,IM,Z)	%3D-Hhenlinien
grid on
title('\it{3D-Hhenlinien}')
xlabel('\it{Realteil}')
ylabel('\it{Imaginrteil}')
zlabel('\it{Betrag von z}')
subplot(224), mesh(RE,IM,Z)		%3D-Grafik mit Netzoberflche
grid on
title('\it{3D-Netz}')
xlabel('\it{Realteil}')
ylabel('\it{Imaginrteil}')
zlabel('\it{Betrag von z}')
