%MATLAB Script-File diskret_167.m
%Diskretisierung eines PT1-Elements
KS=2; T1=1; T=0.1;	%T ist die Abtastzeit
numG=KS; denG=[T1 1];%Zhler- und Nennerpolynom PT1-Element
G=tf(numG,denG);	%G(s)
fprintf('\nG(s) mit Halteglied nullter Ord. --> G(z):')
dG=c2d(G,T,'zoh') 	%G(s) --> dG(z)

fprintf('\nG(z) mit Halteglied nullter Ord. --> G(s):')
G=d2c(dG,'zoh') 	%dG(z) --> G(s)

fprintf('\nG(s) mit Trapeznherung (TUSTIN) --> G(z):')
dG=c2d(G,T,'tustin')%G(s) --> dG(z)

fprintf('\nG(z) mit Trapeznherung (TUSTIN) --> G(s):')
G=d2c(dG,'tustin') 	%dG(z) --> G(s)
