%MATLAB Script-file: beispiel_4_3_10_m.m
clf, clear

tmax = 8; t = 0:0.001:tmax;
KP = 0.5; T1 = 1.0;
lw = 2.0; as = -0.5;
%Allpass I. Ordnung
sim ('beispiel_4_3_10')

plot(u.time,u.signals.values(:,1),'k','LineWidth',lw)
hold on, grid on
plot(u.time,u.signals.values(:,2),'k--','LineWidth',lw)
plot(u.time,u.signals.values(:,3),'k-.','LineWidth',lw)
title ('Signalkomponenten eines Allpass-Elements I. Ordnung')
xlabel ('Zeit  t / s'), ylabel ('Signale')
axis ([as tmax -0.525   0.525])
legend('    u_a(t)','u_D_T_1(t)','u_P_T_1(t)');   

plot ([0 tmax], [0  0],'k','LineWidth',1)
plot ([0 0], [0  -0.5],'k--','LineWidth',lw)
plot ([0 0], [0  -0.5],'k','LineWidth',lw)
plot ([as 0], [0  0],'k','LineWidth',lw)
