%Beispiel 14.5-4a, zu Abschnitt 14.5.4.2
%bsp_14_5_04a_m.m, bsp_14_5_04a.mdl
%schaltende Regler mit Rckfhrung

clc;
Kr = 8; Tr = 2; 
e1 = 0.05; e2 = 0.05; y2 = 0.5;
e0 = 1; 
clf;
tmin = -0.4; tmax = 3;
ymin = -0.1; ymax = 1.2;
sim ('bsp_14_5_04a')
hold on
axis ([tmin tmax ymin ymax])
plot([tmin tmax],[0 0],'r-')
plot([0 0],[ymin ymax],'r-')
plot(t, x,'-') % x(t), y(t)
title  ('Regler mit Rckfhrung, e_1 = 0.05, e_2 = 0.05, y_2 = 0.5')
xlabel ('t / s') 
ylabel ('Rckfhrgre xr(t), Eingangsgre xe(t), Stellgre y(t)')
grid on
text (1.2, 1.1,'xr(t)');
text (0.1, 0.9,'xe(t)');
text (0.38, 0.55,'y(t),  y(t)');
text (1.35, 0.55,'y(t)');
text (2.258, 0.26,'y(t)');
